unit hiMediaPlayerEx;

interface

uses Kol,Share,Media,Windows,Messages,mmsystem,Debug;

type
  ThiMediaPlayerEx = class(TDebug)
   private
    FMedia:PKOLMediaPlayer;
    WndH:HWND;
    Th:PTimer;
    durat:double;
    procedure _OnEnd(Sender:PObj);
    procedure SetVideoScale(Value:byte);
   public
    _prop_Filename:string;
    _data_FileName:THI_Event;
    _data_VideoScale:THI_Event;
    _data_Handle:THI_Event;
    _data_StartPos:THI_Event;
    _data_EndPos:THI_Event;
    _data_Volume:THI_Event;
    _data_Bass:THI_Event;
    _data_Treble:THI_Event;
    _event_onEndPlay:THI_Event;

    constructor Create{(Control:PControl)};
    destructor Destroy; override;
    procedure _work_doPlay(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    procedure _work_doPause(var _Data:TData; Index:word);
    procedure _work_doPosition(var _Data:TData; Index:word);
    procedure _work_doVideoLeft(var _Data:TData; Index:word);
    procedure _work_doVideoWidth(var _Data:TData; Index:word);
    procedure _work_doVideoTop(var _Data:TData; Index:word);
    procedure _work_doVideoHeight(var _Data:TData; Index:word);
    procedure _work_doSetSpeed(var _Data:TData; Index:word);
    procedure _work_doPlayAudioLeft(var _Data:TData; Index:word);
    procedure _work_doPlayAudioRight(var _Data:TData; Index:word);
    procedure _work_doVideoScale(var _Data:TData; Index:word);
    procedure _work_doVolume(var _Data:TData; Index:word);
    procedure _var_Position(var _Data:TData; Index:word);
    procedure _var_Length(var _Data:TData; Index:word);
    procedure _var_State(var _Data:TData; Index:word);
    property _prop_VideoScale:byte write SetVideoScale;
  end;

implementation

constructor ThiMediaPlayerEx.Create;
begin
try
   inherited Create;
   FMedia := NewKOLMediaPlayer('',ReadHandle);
   FMedia.TimeFormat := tfMilliseconds;
   FMedia.Display := ReadHandle;

   Th := NewTimer(300);
   Th.OnTimer := _OnEnd;
except end;
end;

procedure ThiMediaPlayerEx._OnEnd;
begin
try
   if FMedia.Position >= FMedia.Length then
    begin
      th.Enabled := false;
      _hi_OnEvent(_event_onEndPlay);
    end;
    except end;
end;

procedure ThiMediaPlayerEx.SetVideoScale;
begin
try
   FMedia.Scale := Value;
   except end;
end;

procedure ThiMediaPlayerEx._work_doVideoScale;
begin
try
   FMedia.Scale := ReadInteger(_Data,_data_VideoScale,0);
except end;
end;

destructor ThiMediaPlayerEx.Destroy;
begin
try
   FMedia.Free;
   inherited Destroy;
except end;
end;

procedure ThiMediaPlayerEx._work_doPlay;
var
   FName:string;
   FS:PStream;
   buff: array [1..3] of Char;
begin
durat := 1;
FName := ReadString(_Data,_data_FileName,_prop_FileName);
WndH := ReadInteger(_Data,_data_Handle,0);
FS := NewReadFileStream(FName);
try
FS.Seek(8,spBegin);
FS.Read(buff, 3);
if buff = 'AVI' then durat := 41.7;
  finally
    Free_And_Nil(FS);
  end;
   try
   if FileExists(FName) then
    begin
     FMedia.Close;
     FMedia.FileName := FName;
     FMedia.Open;
     FMedia.Play(WndH,0,FMedia.Length);
     Th.Enabled := true;
    end;
    except end;
end;


procedure ThiMediaPlayerEx._work_doPlayAudioLeft;
var Chn:TSoundChannels;
begin
 Chn := [chLeft];
 FMedia.AudioOn[Chn] := ReadBool(_Data);
end;

procedure ThiMediaPlayerEx._work_doPlayAudioRight;
var Chn:TSoundChannels;
begin
 Chn := [chRight];
 FMedia.AudioOn[Chn] := ReadBool(_Data);
end;

procedure ThiMediaPlayerEx._work_doVideoLeft;
var R:TRect;
begin
 R.Left := ToInteger(_Data);
 R.Right := FMedia.DisplayRect.Right;
 R.Top := FMedia.DisplayRect.Top;
 R.Bottom := FMedia.DisplayRect.Bottom;
 FMedia.DisplayRect := R;
end;

procedure ThiMediaPlayerEx._work_doVideoWidth;
var R:TRect;
begin
 R.Right := ToInteger(_Data);
 R.Left := FMedia.DisplayRect.Left;
 R.Top := FMedia.DisplayRect.Top;
 R.Bottom := FMedia.DisplayRect.Bottom;
 FMedia.DisplayRect := R;
end;

procedure ThiMediaPlayerEx._work_doVideoTop;
var R:TRect;
begin
 R.Top := ToInteger(_Data);
 R.Right := FMedia.DisplayRect.Right;
 R.Left := FMedia.DisplayRect.Left;
 R.Bottom := FMedia.DisplayRect.Bottom;
 FMedia.DisplayRect := R;
end;

procedure ThiMediaPlayerEx._work_doVideoHeight;
var R:TRect;
begin
 R.Bottom := ToInteger(_Data);
 R.Right := FMedia.DisplayRect.Right;
 R.Top := FMedia.DisplayRect.Top;
 R.Left := FMedia.DisplayRect.Left;
 FMedia.DisplayRect := R;
end;

procedure ThiMediaPlayerEx._work_doStop;
begin
   FMedia.Stop;
   FMedia.Position := 0;
   th.Enabled := false;
   FMedia.Close;
end;

procedure ThiMediaPlayerEx._work_doPause;
begin
   FMedia.Pause := not FMedia.Pause;
   th.Enabled := not FMedia.Pause;
end;

procedure ThiMediaPlayerEx._work_doPosition;
begin
   if FMedia.Length >= 0 then
    begin
      FMedia.Position := Trunc(ToInteger(_Data) / durat);
      FMedia.Play(WndH,0,FMedia.Length);
    end;
end;

procedure ThiMediaPlayerEx._work_doSetSpeed;
begin
      FMedia.DGV_Speed := ToInteger(_Data);
end;

procedure ThiMediaPlayerEx._work_doVolume;
begin
      FMedia.Volume:=ReadInteger(_Data, _data_Volume, 0);
end;

procedure ThiMediaPlayerEx._var_Position;
begin
    _Data.data_type := data_int;
    _Data.idata := trunc(FMedia.Position * durat);
end;

procedure ThiMediaPlayerEx._var_Length;
begin
    _Data.data_type := data_int;
    _Data.idata := trunc(FMedia.Length * durat);
end;

procedure ThiMediaPlayerEx._var_State;
begin
try
    _Data.data_type := data_int;
    if FMedia.State = mpStopped then _Data.idata:=0;
    if FMedia.State = mpPlaying then _Data.idata:=1;
    if FMedia.State = mpRecording then _Data.idata:=2;
    if FMedia.State = mpSeeking then _Data.idata:=3;
    if FMedia.State = mpPaused then _Data.idata:=4;
    if FMedia.State = mpOpen then _Data.idata:=5;
    if FMedia.State = mpNotReady then _Data.idata:=6;
except end;
end;

end.
